`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 11/17/2017 09:43:02 AM
// Design Name: 
// Module Name: bram
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////

module bram
	#(
	parameter DATA 		= 8,
	parameter ADDR		= 16
    )
    (
    // Port A
    input   wire                clk,
    input   wire                we,
    input   wire    [ADDR-1:0]  addr,
    input   wire    [DATA-1:0]  din,
    output  reg     [DATA-1:0]  dout
    );
    
    // Shared memory
    reg [DATA-1:0] mem [(2**ADDR)-1:0];
     
    // Port A
    always @(posedge clk) 
    	begin
        	if (we) 
            		mem[addr]	 	<= din;
        	else
              	dout     			<= mem[addr];
    	end
    	
endmodule
