`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 11/16/2017 08:55:54 AM
// Design Name: 
// Module Name: top
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module top
	(
	output		[15:0]		memAB,
	output		[7:0]		memDO,

	input 					clk,
	input					rst_n
	);

	////////////////////////////////////////////////////////////////////////////
    // Instantiate the 64k of BlockRAM for main memory
    ////////////////////////////////////////////////////////////////////////////
    wire					memWE;				// Write-enable
    wire	[7:0]			memDI;				// Data read from memory
    
    bram mem_inst
    	(
    	.clk(clk),
    		
    	.addr(memAB),
    	.we(memWE),
    	.din(memDI),
    	.dout(memDO)
    	);
	
	
	////////////////////////////////////////////////////////////////////////////
    // Instantiate the CPU
    ////////////////////////////////////////////////////////////////////////////
    reg						irq_n;				// External in: IRQ
    reg						nmi_n;				// External in: Non-maskable IRQ
    
	
	cpu cpu_inst
		(
		.clk(clk),								// System clock
		.reset(~rst_n),							// Active high reset
		
		.DI(memDO),								// Read:  data @ (address)
		.DO(memDI),								// Write)
		.AB(memAB),								// Address bus
		.WE(memWE),								// Write-enable
		
		.RDY(1'b1),								// Pause the CPU if low
		.IRQ(irq_n),							// external IRQ if low
		.NMI(nmi_n)							// non-maskable IRQ if low
		);

endmodule
